var VK_HOST = "oauth.vk.com";
var ASK_HOST = "ask.fm";
var TT_HOST = "api.twitter.com";
var FB_HOST = "m.facebook.com";
var ACCOUNT_PAGE = "http://ask.fm";
var ERR_CODE_BOT_BEFORE = 303;				
var ERR_CODE_BOT_NOPE = 304;
var ERR_CODE_BOT_LIMIT = 305;
var OK_STATUS = "ok";
var ERR_STATUS = "err";
var CLICK_TIME = 1000; //msec
var userInfo = null;
var isActionReady = false;
var actionStatus;
var getMetaHead = {ready:false};
var logs = new Array();
var tryLoginCnt = 0;

window.onerror = function(message, url, lineNumber) {
	var message = message + " : " + url + " " + lineNumber;
	logs.push({type:"error", location: "EMBED", date: new Date().toUTCString(), prefix: "EMBED_BROWSER", message: message});
};

function debug(prefix, message){
	logs.push({type:"debug", location: "EMBED", date: new Date().toUTCString(), prefix: prefix, message: message});
}

function getLogs(){
	setTimeout(function(){logs = new Array();},0);
	return JSON.stringify(logs);
}
	
function curPath(needClear){
	if((window.location.hostname == ASK_HOST && window.location.pathname.indexOf("login") !== -1)){
		cookieOk();
	}else if(window.location.hostname == ASK_HOST && window.location.pathname.indexOf("wall") !== -1){
		prepareWall();
	}else{
		if(needClear)
			clear();
	}
	
	return getLocation();
}

function getLocation(){
	var isLoaded = false;
	if(window.location.hostname == ASK_HOST && window.location.pathname.indexOf("wall") !== -1){
		clearImages();
		var style = $("#loaderMother").attr("style");
		if(style.indexOf("none") !== -1){
			 isLoaded = true;
		}
	}
	var data_id = document.getElementsByTagName("body")[0].getAttribute("data-id");
	
	var location = {host: window.location.hostname, path: window.location.pathname, isLoaded:isLoaded, data_id:data_id};
	return JSON.stringify(location);
}

function action(url, addon){
	url += addon;
	if(window.jQuery){
		$.ajax({
			url: url,
			type: 'POST',
			beforeSend: function (request)
			{
				var token = $("meta[name='csrf-token']").attr("content");
				request.setRequestHeader("X-CSRF-Token", token);
			},
			success: function(response){
				actionStatus = OK_STATUS;
				isActionReady = true;
			},
			error: function(e){
				if(e.status == 404)
					actionStatus = ERR_CODE_BOT_NOPE;
				else if(e.status == 403)
					actionStatus = ERR_CODE_BOT_LIMIT;
				else
					actionStatus = ERR_STATUS;
				isActionReady = true;
			}
		});
	}else{
		actionStatus = ERR_CODE_BOT_NOPE;
		isActionReady = true;
	}
}

function actionAsk(url, addon, question){
	url += addon;
	var params = "utf8=✓&question[question_text]="+question+"&question[anonymous]=0";
	if(window.jQuery){
		$.ajax({
			url: url,
			type: 'POST',
			data: params,
			beforeSend: function (request)
			{
				var token = $("meta[name='csrf-token']").attr("content");
				request.setRequestHeader("X-CSRF-Token", token);
			},
			success: function(response){
				actionStatus = OK_STATUS;
				isActionReady = true;
			},
			error: function(e){
				if(e.status == 404)
					actionStatus = ERR_CODE_BOT_NOPE;
				else
					actionStatus = ERR_STATUS;
				isActionReady = true;
			}
		});
	}else{
		actionStatus = ERR_CODE_BOT_NOPE;
		isActionReady = true;
	}
}

function getActionEntity(){
	setTimeout(function(){isActionReady = false;},0);
	var action = {ready:isActionReady, status: actionStatus};
	return JSON.stringify(action);
}

function goPage(page){
	window.location.href = page;
}

function logout(){
	$(".accountSettings a:last").click();
}

function login_base(login, password){
	cookieOk();
	prepareLogin();
	document.getElementsByName('login')[0].value = login;
	document.getElementsByName('password')[0].value = password;
	var arr = "focus change input keydown keypress keyup blur".split(" ");
	
	for(i=0; i< arr.length; i++){
		$('input[name=login]:first').trigger(arr[i]);
	}
	setTimeout(function(){
		$(".btn-primary-wide:first").click();
	}, CLICK_TIME);
}

function checkCaptcha(){
	var style = $(".captchaContainer:first").attr("style"); 
	return JSON.stringify({captcha: style.indexOf("none") === -1});
}

function checkCaptchaVk(){
	var captcha = document.getElementById("captcha");
	return JSON.stringify({captcha: captcha != null});
}

function login_vk(login, password){
	if(window.location.hostname == VK_HOST){
		document.getElementsByName('email')[0].value = login;
		document.getElementsByName('pass')[0].value = password;	//password for desktop
		document.getElementsByClassName("button")[0].click();								//#install_allow for desktop
	}else{
		cookieOk();
		$(".icon-vk-solo:first").click();
	}
}

function login_tt(login, password){
	if(window.location.hostname == TT_HOST){
		if(document.getElementById('username_or_email') != null){
			document.getElementById('username_or_email').value = login;
			document.getElementById('password').value = password;
			document.getElementById('remember').click();
		}
		document.getElementById("allow").click();								
	}else{
		cookieOk();
		$(".icon-twitter-solo:first").click();
	}
}

function login_fb(login, password){
	if(window.location.hostname == FB_HOST){
		document.getElementsByName('email')[0].value = login;			//#email for desktop
		document.getElementsByName('pass')[0].value = password;
		document.getElementsByName("login")[0].click();								
	}else{
		cookieOk();
		$(".icon-facebook-solo:first").click();
	}
}

function goProfile(){
	var profilePage = ACCOUNT_PAGE + "/" + $("#user_login").val();
	//console.log(profilePage);
	goPage(profilePage);
}

function getUserInfo(){
	var html = document;
	var nick = $(html).find(".profile-name span:eq(1)").text().trim();
	nick = nick.replace("@","");
	var subscribersCount =  $(html).find(".profile-label span strong:first").text().trim();
	var answersCount = $(html).find(".profileTabAnswerCount:first").text().trim();
	var likesCount = $(html).find(".profileTabLikeCount:first").text().trim();
	//var profileAvatar = $(html).find(".profile-picture").attr("data-url") + "";

	var avatarUrl = document.querySelector(".profile-picture").style.backgroundImage;
	var profileAvatar = avatarUrl.substring(4, avatarUrl.length-1).replace(/\"/g,'');

	if(profileAvatar.indexOf("http") === -1){
		profileAvatar = "http:" + profileAvatar;
	}
	var answers = new Array();
	$(html).find(".item").each(function(){
		var author = $(this).find(".questionersName:first").text().trim();
		$(this).find(".questionersName:first").text("");
		var question = $(this).find(".streamItemContent-question:first").text().trim();
		var answer = $(this).find(".streamItemContent-answer:first").text().trim();
		var likesCount = $(this).find(".counter:first").text().trim();
		var id = $(this).find(".streamItemsAge:first").attr("href").trim();
		var temp = id.split("/");
		id = temp[temp.length - 1];
		answers.push({question: question, answer: answer, likesCount: likesCount, id: id, author: author});
	});
	
	userInfo = {nick: nick, profileAvatar: profileAvatar, subscribersCount: subscribersCount, answersCount: answersCount, likesCount: likesCount, answers: answers};
	return JSON.stringify(userInfo);
}

function getInfoEntity(){
	var tmp = userInfo;
	if(userInfo != null)
		userInfo = null;
	return JSON.stringify(tmp);
}

function getLikeInfo(){
	var res = null;
	if(window.jQuery){
		var item = $(".item:first");
		if(item.length != 0){
			var head = item.find(".streamItemContent-question:first").text().trim();
			var meta = item.find(".streamItemContent-answer:first").text().trim();
			
			var metaHead = {head: head, meta: meta};
			res = {status: OK_STATUS, metaHead: metaHead};
		}else{
			res = {status: ERR_STATUS};
		}
		
	}else{
		res = {status:ERR_STATUS};
	}
	
	return JSON.stringify(res);
}

function getSubscribeInfo(){
	var res = null;
	if(window.jQuery){
		var head = $(".profile-name span:eq(1)").text().trim();
		head = head.replace("@","");
		var meta = $(".profile-name span:eq(0)").text().trim();
		if(head != "" && meta != ""){
			var metaHead = {head: head, meta: meta};
			res = {status: OK_STATUS, metaHead: metaHead};
		}else{
			res = {status: ERR_STATUS};
		}
	}else{
		res = {status: ERR_STATUS};
	}
	return JSON.stringify(res);
}

function getMetaHeadEntity(){
	setTimeout(function(){getMetaHead = {ready: false};}, 0);
	return JSON.stringify(getMetaHead);
}

function shutPromotions(){
	document.getElementsByClassName("askfm-strip")[0].click();
}

function cookieOk(){
	$(".cookie .rsp-container:first a:last").click();
}

function clear(){
	if(!(window.location.hostname == ASK_HOST && window.location.pathname.indexOf("login") !== -1)){
		clearImages();
		clearCss();
	}
}

function clearImages(){
	var images = document.getElementsByTagName("img");
	for(var i=0; i<images.length; i++){
		var src = images[i].getAttribute("src");
		if(src != "")
		images[i].setAttribute("src_embed", src);
		images[i].setAttribute("src", "");
	}
}

function clearCss(){
	var links = document.getElementsByTagName("link");
	for(var i=0; i<links.length; i++){
		var href = links[i].getAttribute("href");
		if(href != "")
		links[i].setAttribute("href_embed", href);
		links[i].setAttribute("href", "");
	}
}

function prepareWall(){
	$("#loaderMother").show();
	$("#topMenu").hide();
	$("#contentArea").hide();
	clearImages();
}

function prepareLogin(){
	$("body").css("background-color", "white");
	var html = "<a style='margin-left:20px;' class='appPromoterItem icon-askfm-solo'></a>"+
			   "<a class='appPromoterItem appPromoter-label'>"+
					"<strong>Ask.fm</strong>"+
					"Authorization"+
				"</a>";
	$("#appPromoter").html(html);
	$(".topBar:first").html("");
	$("#contentArea").css("position", "absolute");
	$("#contentArea").css("width", "100%");
	$("#contentArea").css("top", "70px");
	$(".loginServices:first").html("");
	$(".simpleFormItem:eq(1)").html("");
}

function prepareLoginVk(){
	
}