var Action = Base.extend({

	callback: null,
	waiting: null,
	action: null,				//action in const
	embed: null,
	type: null, 				//bot or browser
	params: null,
	toid: null,
	
	
	constructor: function(type, action, params, callback, embed){
		this.type = type;
		this.action = action;
		this.params = params;
		this.waiting = callback;
		this.embed = embed;
	},

	startAction: function(callback){
		var self = this;
		this.callback = function(response){
				clearTimeout(this.toid);
				self.waiting(response);
				callback();
		}
		this.embed.action = this.action;
		switch(this.action){
			case Constant.INIT_ACTION:
				this.init();
				break;
			case Constant.AUTH_ACTION:
				this.auth();
				break;
			case Constant.GET_INFO_ACTION:
				this.getUserInfo();
				break;
			case Constant.LOGOUT_ACTION:
				this.logout();
				break;
			case Constant.GET_MH_ACTION:
				this.getMetaHead();
				break;
			case Constant.LIKE_ACTION:
				this.like();
				break;
			case Constant.SUBSCRIBE_ACTION:
				this.subscribe();
				break;
			case Constant.QUESTION_ACTION:
				this.question();
				break;
			case Constant.LOGS_ACTION:
				this.logs();
				break;
		}
	},
	
	
	init: function(){
		var embed = this.embed;
		
		this.startThrowwer(Constant.INITIALIZE_TIME, Constant.ERR_STATUS);
		
		embed.bot = window.open(encodeURI(Constant.START_PAGE), '_blank', 'hidden=yes');
		embed.bot.addEventListener('loadstop', embed.loadStop);
		embed.bot.addEventListener('loadstart', embed.loadStart);
		embed.bot.addEventListener('exit', embed.exit);
	},
	
	auth: function(){
		var embed = this.embed;
		Log.d("AUTH", "IN FUNCTION");
		if(embed.isLogin){
			Log.d("AUTH", "OK");
			this.callback(Constant.OK_STATUS);
		}else{
			Log.d("AUTH", "TRY LOGIN");
			embed.bot.executeScript({code: "cookieOk();"});
			embed.checkStupidDevice(EmbedEntity.self);
			embed.visible = true;
			embed.bot.show();
		}
	},
		
	getUserInfo: function(){
		var embed = this.embed;
		var user = this.params.user;
		var self = this;
		Log.d("GET_USER_INFO", "IN FUNCTION");
		if(embed.isLogin){
			this.startThrowwer(Constant.GET_INFO_TIME, null);
			if(user.getNick() == null){
				embed.bot.executeScript({code: "goProfile();"});
			}else{
				var profilePage = Constant.HOME_PAGE + user.getNick();
				embed.goPage(profilePage);
			}
		}else{
			this.callback(Constant.ERR_STATUS);	
		}
	},
	
	logout: function(){
		var embed = this.embed;
		
		if(embed.isLogin){
			this.startThrowwer(Constant.LOGOUT_TIME, Constant.ERR_STATUS);
			embed.goPage(Constant.SETTINGS_PAGE);
		}else{
			this.callback(Constant.OK_STATUS);	
		}
	},
	
	logs: function(){
		var embed = this.embed;
		var self = this;
		if(embed.isLogin){
			self.startThrowwer(Constant.LOGS_TIME, Constant.ERR_STATUS);
			embed.bot.executeScript({code: "getLogs();"}, function(logs){
				logs = JSON.parse(embed.s(logs));
				self.callback(logs)
			});
		}else{
			this.callback(null);	
		}
	},
	
	getMetaHead: function(){
		var embed = this.embed;
		
		if(embed.isLogin){
			this.startThrowwer(Constant.GET_MH_TIME, null);
			
			embed.data = this.params;
			embed.goPage(this.params.bid.getLink());
			
		}else{
			this.callback(null);	
		}
	},
	
	like: function(){
		var embed = this.embed;
		if(embed.isLogin){
			this.startThrowwer(Constant.LIKE_TIME, Constant.ERR_STATUS);
			
			embed.goPage(this.params.quest.getLink());
		}else{
			this.callback(Constant.ERR_STATUS);
		}
	},
	
	subscribe: function(){
		var embed = this.embed;
		if(embed.isLogin){
			this.startThrowwer(Constant.SUBSCRIBE_TIME, Constant.ERR_STATUS);
			
			embed.goPage(this.params.quest.getLink());
		}else{
			this.callback(Constant.ERR_STATUS);
		}
	},
	
	question: function(){
		var embed = this.embed;
		var self = this;
		var embed = this.embed;
		if(embed.isLogin){
			this.startThrowwer(Constant.SUBSCRIBE_TIME, Constant.ERR_STATUS);
			
			embed.goPage(this.params.quest.getLink()+"/ask");
		}else{
			this.callback(Constant.ERR_STATUS);
		}
	},

	startThrowwer: function(time, val){
		this.toid = this.throwwer({action: this.action, time: time, callback: this.callback, val: val});
	},
	
	
	throwwer: function(tobj){
		var self = this;
		return setTimeout(function(){
			tobj.callback(tobj.val);
		},tobj.time);
	},

	callWaiting: function(){},
	
	/* get and set Action.id */
	setId: function(id){
		this.id = id;
	},
	
	getId: function(){
		return this.id;
	},

	/* get and set Action.time */
	setTime: function(time){
		this.time = time;
	},
	
	getTime: function(){
		return this.time;
	},
	
	/* get and set Action.callback */
	setCallback: function(callback){
		this.callback = callback;
	},
	
	getCallback: function(){
		return this.callback;
	},
	
	/* get and set Action.action */
	setAction: function(action){
		this.action = action;
	},
	
	getAction: function(){
		return this.action;
	},

	/* get and set Action.embed */
	setEmbed: function(embed){
		this.embed = embed;
	},
	
	getEmbed: function(){
		return this.embed;
	},

	/* get and set Action.type */
	setType: function(type){
		this.type = type;
	},
	
	getType: function(){
		return this.type;
	},

	/* get and set Action.params */
	setParams: function(params){
		this.params = params;
	},
	
	getParams: function(){
		return this.params;
	},
	
	browserShow: function(){
		
	}
	
	
});