var EmbedEntity = Embed.extend({

	bot: null,
	isUniqLoad: true,
	controller: null,
	isCaptcha: false,
	loadStartUrl: null,
	loadStopUrl: null,
	curHost: null,
	authVkCnt: 0,
	visible: false,
	checker: null,
	
	constructor: function(){
		EmbedEntity.self = this;
		EmbedEntity.self.controller = new EmbedController(EmbedEntity.self);
	},

	/* EmbedBrowser.bot starts */
	init: function(callback){
		Log.d("INIT", "IN_FUNCTION");
		EmbedEntity.self.isLogin = false;
		clearInterval(EmbedEntity.self.checker);
		EmbedEntity.self.isUniqLoad = true;
		Log.d("INIT", "CREATED_ACTION_BEFORE");
		EmbedEntity.self.controller.addAction(new Action(Constant.BROWSER, Constant.INIT_ACTION, {}, callback, EmbedEntity.self));
		Log.d("INIT", "CREATED_ACTION");
		EmbedEntity.self.controller.nextAction();
	},
	
	loadStart: function(event){
		var self = EmbedEntity.self;
		self.isUniqLoad = true;
		self.loadStartUrl = event.url;
		Log.d("LOAD_START", event.url + " " + event.url.indexOf(Constant.REG_PAGE_STRING));
		if(event.url.indexOf(Constant.WALL_PAGE_STRING) !== -1 || event.url.indexOf(Constant.SETTINGS_PAGE_STRING) !== -1){
			Log.d("WALL", "here");
			EmbedEntity.self.isLogin = true;
									
			if(self.visible){
				self.reinit();
			}
		}else if(event.url.indexOf(Constant.REG_PAGE_STRING) !== -1){
			Log.d("HERE", "Go LOGIn");
			
			EmbedEntity.self.isLogin = false;
			EmbedEntity.self.bot.executeScript({code: "window.location = " + "'"+Constant.LOGIN_PAGE+"'"});
		}else{
			setTimeout(function(){
				if(event.url.indexOf(Constant.LOGIN_PART) === -1){
					$.get("js/gap/embedClear.js", function(data){
						if(self.bot != null){
							self.bot.executeScript({code: data}, function(){
								self.bot.executeScript({code: "clear();"}, function(data){
									
								});
							});
						}
					});
				}
			}, Constant.CLEAR_TIMEOUT);
		}
	},
	
	loadStop: function(event){
		Log.d("LOAD_STOP", event.url);
		var self = EmbedEntity.self;
		self.loadStopUrl = event.url;
		if(self.isUniqLoad || self.loadStopUrl != self.loadStartUrl){
			self.isUniqLoad = false;
			self.loadStartUrl = self.loadStopUrl;
			//var script = Constant.SERVER_HOST + "embeds/embedBrowser.js";
			var script = "js/gap/embedBrowser.js";
			
			if(self.controller.getCurAction() != null)
				if(self.controller.getCurAction().getType() == Constant.BOT){
					script = "js/gap/embedBot.js";
				}
			if(event.url.indexOf(Constant.WALL_PAGE_STRING) !== -1){
				Log.d("WALL", "here");
				EmbedEntity.self.isLogin = true;
										
				if(self.visible){
					self.reinit();
				}
			}else{
				$.get(script, function(data){
					if(self.bot != null){
						self.bot.executeScript({code: data}, function(){
							var needClear = self.visible ? 0 : 1;
							if(self.bot != null){
								self.bot.executeScript({code: "curPath("+needClear+");"}, function(data){
									data = JSON.parse(self.s(data));
									self.curHost = self.s(data.host);
									self.fireAction(data);
								});
								
							}
						});
					}
				});
			}
		}
	},
	
	exit: function(){
		var self = EmbedEntity.self;
		if(self.visible)
			self.controller.getCurAction().callback(Constant.ERR_CODE_BROWSER_CLOSED);
		self.visible = false;
	},
	
	fireAction: function(data){
		var self = EmbedEntity.self;
		if(self.s(data.host) == Constant.ASK_HOST){		//it is ask
			self.route(data.path);
		}
	},
		
	/* set route by path */
	route: function route(path){
		var parts = path.split("/");
		var self = EmbedEntity.self;
		
		Log.d("ROUTE", path);
		Log.d("ROUTE_ACTION", EmbedEntity.self.action);
		self.curPath = path;
		self.curPart = parts[1];
		if(parts.length > 1){
			switch(parts[1]){
				case Constant.LOGIN_PART:
					Log.d("ROUTE_PART", "IN_LOGIN_PART");
					//bot.executeScript({code: "login();"});
					self.isLogin = false;
					if(EmbedEntity.self.action == Constant.INIT_ACTION){
							Log.d("ROUTE_PART_ACTIONACTION", "OK");
							self.bot.executeScript({code: "getLocation();"}, function(data){
								data = JSON.parse(self.s(data));
								var data_id = self.s(data.data_id);
								Log.d("DATA_ID", data_id);
								if(data_id.indexOf("profile") !== -1){
									Log.d("LIGIN_PART", "OK_IN");
									self.controller.getCurAction().callback(Constant.OK_STATUS_IN);
								}else{
									Log.d("LIGIN_PART", "OK");
									self.controller.getCurAction().callback(Constant.OK_STATUS);
								}
							});
							
					}
					break;
				case Constant.ACCOUNT_PART:
					self.isLogin = true;
					switch(parts[2]){
						case Constant.WALL_PART:
							if(self.action == Constant.AUTH_ACTION){		//auth ok
									
									if(self.visible){
										self.reinit();
									}
							}
							if(self.action == Constant.INIT_ACTION){
								self.controller.getCurAction().callback(Constant.OK_STATUS_IN);
							}
							break;
						case Constant.SETTINGS_PART:
							if(self.action == Constant.LOGOUT_ACTION){		//call logout method
								self.bot.executeScript({code: "logout();"});
							}
							if(self.action == Constant.INIT_ACTION){
								self.controller.getCurAction().callback(Constant.OK_STATUS_IN);
							}
							break;						
					}
					
					break;
				case Constant.HOME_PART:
					EmbedEntity.self.isLogin = false;
					if(EmbedEntity.self.action == Constant.LOGOUT_ACTION){		//logout ok
							self.controller.getCurAction().callback(Constant.OK_STATUS);
							setTimeout(function(){
								self.goPage(Constant.LOGIN_PAGE);
							}, 1);
					}
					break;
				default:
					if(self.action == Constant.GET_INFO_ACTION){					//Get user info action
						setTimeout(function(){
							EmbedEntity.self.bot.executeScript({code: "getUserInfo();"}, function(userInfo){
								userInfo = JSON.parse(self.s(userInfo));
								userInfo = new UserInfo(userInfo);
								self.controller.getCurAction().callback({userInfo: userInfo});
							});
						}, 200);
					}
					if(self.action == Constant.GET_MH_ACTION){
						switch(self.data.bid.getType()){
							case Constant.LIKE_TYPE:
								self.bot.executeScript({code: "getLikeInfo();"}, function(data){
									data = JSON.parse(self.s(data));
									self.controller.getCurAction().callback(data);
								});
								break;
							case Constant.SUBSCRIBE_TYPE:
								self.bot.executeScript({code: "getSubscribeInfo();"}, function(data){
									data = JSON.parse(self.s(data));
									self.controller.getCurAction().callback(data);
								});
								break;
							case Constant.QUEST_TYPE:
								self.bot.executeScript({code: "getSubscribeInfo();"}, function(data){
									data = JSON.parse(self.s(data));
									self.controller.getCurAction().callback(data);
								});
								break;
						}
					}
					
					if(self.action == Constant.LIKE_ACTION){
						self.bot.executeScript({code: "like();"}, function(data){
							data = self.s(data);
							self.controller.getCurAction().callback(data);
						});
					}
					
					if(self.action == Constant.SUBSCRIBE_ACTION){
						self.bot.executeScript({code: "subscribe();"}, function(data){
							data = self.s(data);
							self.controller.getCurAction().callback(data);
						});
					}
					
					if(self.action == Constant.QUESTION_ACTION){
						var params = self.controller.getCurAction().params;
						Manager.instance.getConnector().getQuestion(params.quest.getLang(), function(result){
							if(result.status == Constant.OK_STATUS){
								self.bot.executeScript({code: "question('"+result.question+"');"}, function(data){
									data = self.s(data);
									self.controller.getCurAction().callback(data);
								});
							}else{
								self.callback(Constant.ERR_STATUS);
							}
						});
						
					}
					break;
			}
		}else{
			
			
		}
	},

	/* EmbedBrowser.bot authorizations */
	auth: function(callback){
		EmbedEntity.self.controller.addAction(new Action(Constant.BROWSER, Constant.AUTH_ACTION, {}, callback, EmbedEntity.self));
		EmbedEntity.self.controller.nextAction();							
	},


	/* EmbedBrowser.bot logouts */
	logout: function(callback){
		EmbedEntity.self.controller.addAction(new Action(Constant.BROWSER, Constant.LOGOUT_ACTION, {}, callback, EmbedEntity.self));
		EmbedEntity.self.controller.nextAction();
	},
	
	goPage: function(page){
		EmbedEntity.self.bot.executeScript({code: "goPage('"+page+"');"});
	},

	/* get user info */
	getUserInfo: function(user, callback){
		EmbedEntity.self.controller.addAction(new Action(Constant.BROWSER, Constant.GET_INFO_ACTION, {user: user}, callback, EmbedEntity.self));
		EmbedEntity.self.controller.nextAction();
	},

	/* update EmbedBrowser.bot */
	update: function(user, callback){
		EmbedEntity.self.getUserInfo(user, callback);
	},

	/* get meta and head from bid */
	getMetaHead: function(bid, callback){
		EmbedEntity.self.controller.addAction(new Action(Constant.BROWSER, Constant.GET_MH_ACTION, {bid: bid}, callback, EmbedEntity.self));
		EmbedEntity.self.controller.nextAction();
	},
	
	getAuthMethod: function(authData){
		var loginPassword = "'"+authData.getLogin()+"','"+authData.getPassword()+"'";
		var method = "login_";
		switch(authData.getAuthType()){
			case Constant.BASE_AUTH: method += "base"; break;
			case Constant.TT_AUTH: method += "tt"; break;
			case Constant.VK_AUTH: method += "vk"; break;
			case Constant.FB_AUTH: method += "fb"; break;
		}
		return method+"("+loginPassword+");";
	},
	
	/* set like by link */
	like: function(quest, callback){
		EmbedEntity.self.controller.addAction(new Action(Constant.BOT, Constant.LIKE_ACTION, {quest: quest}, callback, EmbedEntity.self));
		EmbedEntity.self.controller.nextAction();
	},
	
	/* set like by link */
	getLogs: function(callback){
		EmbedEntity.self.controller.addAction(new Action(Constant.BROWSER, Constant.LOGS_ACTION, {}, callback, EmbedEntity.self));
		EmbedEntity.self.controller.nextAction();
	},
	
	/* set like by link */
	question: function(quest, callback){
		EmbedEntity.self.controller.addAction(new Action(Constant.BOT, Constant.QUESTION_ACTION, {quest: quest}, callback, EmbedEntity.self));
		EmbedEntity.self.controller.nextAction();
	},
	
	/* set like by link */
	reinit: function(callback){
		var self = EmbedEntity.self;
		self.visible = false;						//before we close is important for exit()
		self.action = Constant.NULL_ACTION;
		self.bot.removeEventListener('loadstart', self.loadStart);
		self.bot.removeEventListener('loadstop', self.loadStop);
		self.bot.removeEventListener('exit', self.exit);
		self.bot.close();
		self.bot = null;
		self.controller.getCurAction().callback(Constant.ERR_CODE_BROWSER_REINIT);
	},
	
	checkStupidDevice: function(self){
		var isIn = false;
		Log.d("CHECK_STUPID_DEVICE", "start");
		if(self.action == Constant.AUTH_ACTION && !self.isLogin){
			Log.d("CHECK_STUPID_DEVICE", "init it");
			self.checker = setInterval(function(){
				if(!isIn){
					isIn = true;
					self.bot.executeScript({code: "getLocation();"}, function(data){
						data = JSON.parse(self.s(data));
						Log.o("CHECK_STUPID_DEVICE_DATA", data);
						Log.d("CHECK", self.curPath + " " + self.loadStartUrl + " " + self.loadStopUrl);
						if(self.curPath != data.path && self.loadStartUrl.indexOf(data.path) === -1 
							&& self.loadStopUrl.indexOf(data.path) === -1 && data.data_id.indexOf("profile") !== -1 ){
							clearInterval(self.checker);
						Log.d("CHECK_STUPID_DEVICE", "clear1");
								if(self.visible && self.action == Constant.AUTH_ACTION && !self.isLogin){
									self.reinit();
								}
							
						}else{
							isIn = false;
						}
					});
				}
			}, 1000);
		}else{
			Log.d("CHECK_STUPID_DEVICE", "clear2");
			clearInterval(self.checker);
		}
	},

	/* subscribe by link */
	subscribe: function(quest, callback){
		EmbedEntity.self.controller.addAction(new Action(Constant.BOT, Constant.SUBSCRIBE_ACTION, {quest: quest}, callback, EmbedEntity.self));
		EmbedEntity.self.controller.nextAction();
	}
},{
	self: null
});