var User = Base.extend({
	nick: null,
	id: null,
	askId: null,
	subscribersCount: null,
	answersCount: null, 
	likesCount: null,
	answers: null,
	authData: null,
	cash: null,
	xpInfo: null,
	profileAvatar: null,
	lang: null,
	premium: null,
	turbo: 0,
	settings: [],
	achieves: null, 
	rtime: null,		//reg time ago
	
	constructor: function(){},

	/* log in to User account */
	login: function(){},

	/* log out from User account */
	logout: function(){},
	
	/* get and set User.nick */
	setNick: function(nick){
		this.nick = nick;
	},
	
	getNick: function(){
		return this.nick;
	},
	
	/* get and set User.id */
	setId: function(id){
		this.id = id;
	},
	
	setPremium: function(premium){
		this.premium = (premium == 0 ? false : true);
	},
	
	getPremium: function(){
		return this.premium;
	},
	
	setRtime: function(rtime){
		this.rtime = rtime;
	},
	
	isSafeUser: function(){
		return this.rtime >= Constant.STAY_SAFE_USER_TIME ? true : false;
	},
	
	getRtime: function(){
		return this.rtime;
	},
	
	setTurbo: function(turbo){
		this.turbo = turbo;
	},
	
	getTurbo: function(){
		return this.turbo;
	},
	
	getId: function(){
		return this.id;
	},

	/* get and set User.askId */
	setAskId: function(askId){
		this.askId = askId;
	},
	
	getAskId: function(){
		return this.askId;
	},
	
	/* get and set User.subscribersCount */
	setSubscribersCount: function(subscribersCount){
		this.subscribersCount = subscribersCount;
	},
	
	getSubscribersCount: function(){
		return this.subscribersCount;
	},
	
	/* get and set User.answersCount */
	setAnswersCount: function(answersCount){
		this.answersCount = answersCount;
	},
	
	getAnswersCount: function(){
		return this.answersCount;
	},
	
	/* get and set User.likesCount */
	setLikesCount: function(likesCount){
		this.likesCount = likesCount;
	},
	
	getLikesCount: function(){
		return this.likesCount;
	},
	
	/* get and set User.answers */
	setAnswers: function(answers){
		this.answers = answers;
	},
	
	getAnswers: function(){
		return this.answers;
	},
	
	/* get and set User.authData */
	setAuthData: function(authData){
		this.authData = authData;
	},
	
	getAuthData: function(){
		return this.authData;
	},
	
	/* get and set User.cash */
	setCash: function(cash){
		this.cash = cash;
	},
	
	getCash: function(){
		return this.cash;
	},
	
	setAchieves: function(achieves){
		if(achieves != null)
			this.achieves = achieves;
		else
			this.achieves = new Array();
	},
	
	getAchieves: function(){
		return this.achieves;
	},
	
	setXpInfo: function(xpInfo){
		this.xpInfo = xpInfo;
	},
	
	getXpInfo: function(){
		return this.xpInfo;
	},
	
	changeCash: function(free, busy){
		this.cash.changeSums(free, busy);
	},
	
	getProfileAvatar: function(){
		return this.profileAvatar;
	},
	
	setLang: function(lang){
		this.lang = lang;
	},
	
	getLang: function(){
		return this.lang;
	},
	
	setSetting: function(name, value){
		this.settings["s_"+name] = value;
	},
	
	isFirstTime: function(){
		return this.settings["s_"+Constant.FIRSTTIME_SETTING] == 1 ? true : false;
	},
	
	getSetting: function(name){
		return this.settings["s_"+name];
	},
	
	reset: function(){
		this.nick = null;
		this.id = null;
		this.askId = null;
		this.subscribersCount = null;
		this.answersCount = null;
		this.likesCount = null;
		this.answers = null;
		this.authData = null;
		this.cash = null;
		this.profileAvatar = null;
	},
	
	setUserInfo: function(userInfo){
		this.nick = userInfo.getNick();
		this.answers = userInfo.getAnswers();
		this.answersCount = userInfo.getAnswersCount();
		this.profileAvatar = userInfo.getProfileAvatar();
		Log.d("PROFILE_AVATAR", this.profileAvatar);
		this.likesCount = userInfo.getLikesCount();
		this.subscribersCount = userInfo.getSubscribersCount();
	}
});